import operator, string, time
import httplib, urllib
import xmllib
import sys
import cgi
import time
from types import *
from OFS import Image

__version__ = "0.1.1";

# simple extension methods here

def cloneChannelButton(self):
		self=self.this()
		id='channelButton'
		self._setObject(id, Image.Image(id, 'Channel button', '',	'image/gif', ''))
		# now to fill in the data
		self._getOb(id).update_data(self.defaultButton.data, 'image/gif')

def makeFirst(objMan, selected=[]):
		objs=objMan._objects
		objMan._objects=tuple(filter(lambda obj, selected=selected: 
																 obj['id'] in selected, objs) 
													+
													filter(lambda obj, selected=selected:
																 obj['id'] not in selected, objs)
													)

def bbmtCmp(a, b):
		return cmp(b.bobobase_modification_time, a.bobobase_modification_time)

def siteSummaryEntries(self, REQUEST):
		"""Returns the entries in this Site Summary"""
		if self.meta_index=="":
				r=self.objectValues('SiteSummaryEntry')
		else:
				r=REQUEST['PARENTS'][1].objectValues(self.meta_index)
				r.sort(bbmtCmp)
		return r

# complex import methods follow

class RSSParser(xmllib.XMLParser):
		"""Parse an RSS file"""

		def __init__(self, summ=None):
				self.__item={}
				self.__data=[]
				self.__sitesum=summ
				self.__count=0
				xmllib.XMLParser.__init__(self)

		def start_channel(self, attrs):
				self.__body=0

		def end_channel(self):
				pass

		def start_image(self, attrs):
				self.__itemsave=self.__item
				self.__item={}

		def end_image(self):
				# here's where we set image properties
				# this basically involves fetching the image
				# file into a data string and replacing the current
				# image with it
				type, uri = urllib.splittype(self.__item['url'])
				host, path=urllib.splithost(uri)
				h=httplib.HTTP(host)
				h.putrequest("GET", path)
				h.putheader("User-Agent", "SiteSummary (edd@usefulinc.com)")
				h.putheader("Host", host)
				h.endheaders()
				errcode, errmsg, headers = h.getreply()
				f = h.getfile()
				data = f.read()
				f.close()
				if headers.has_key('content-type'):
						ctype=headers['content-type']
				else:
						ctype='image/gif'

				# now to import the image data
				self.__sitesum.channelButton.update_data(data,
																								 ctype,
																								 len(data))
				# restore the itemstore to how it was before <image>
				self.__item=self.__itemsave

		def insert_header(self):
				# set SiteSummary properties
				# according to info in header
				attrmap={'site_title': 'title',
								 'site_url': 'link',
								 'description': 'description',
								 'copyright': 'copyright',
								 'managingEditor': 'managingeditor',
								 'webMaster': 'webmaster',
								 'language': 'language'}

				for k in attrmap.keys():
						if self.__item.has_key(attrmap[k]):
								setattr(self.__sitesum, k,
												self.__item[attrmap[k]])

				# import url implicitly means we're not indexing
				# other things in our folder
				setattr(self.__sitesum, 'meta_index', '')

		def start_item(self, attrs):
				if self.__body==0:
						self.insert_header()
						self.__body=1
				self.__item={}
				
		def unknown_starttag(self, tag, attrs):
				self.__data = []
				self.__tag=string.lower(tag)

		def unknown_endtag(self, tag):
				self.__item[self.__tag]=string.join(self.__data,"")

		def end_item(self):
				s=self.__sitesum
				tid='item'+`self.__count`
				self.__count=self.__count+1
				se=s.SiteSummaryEntry(tid, 'SiteSummaryEntry', ['ZObject'])
				se.id=tid
				se.url=self.__item['link']
				se.linktext=self.__item['title']
				if self.__item.has_key('description'):
						se.summary=self.__item['description']
				s._setObject(tid, se)

		def handle_data(self, text):
				self.__data.append(text)

		def parse_url(self, url, REQUEST):
				type, uri = urllib.splittype(url)
				if type != "http":
						raise IOError, "Unsupported protocol"
				host, path=urllib.splithost(uri)
				h=httplib.HTTP(host)
				h.putrequest("GET", path)
				h.putheader("User-Agent", "SiteSummary (edd@usefulinc.com)")
				h.putheader("Host", host)
				h.endheaders()
				errcode, errmsg, headers = h.getreply()
				if errcode==200:
						self.__sitesum.manage_delObjects(
								self.__sitesum.objectIds('SiteSummaryEntry'), REQUEST)
						f = h.getfile()
						data = f.read()
						f.close()
						self.feed(data)

def sitesummary_import(self, REQUEST):
		p=RSSParser(self)
		p.parse_url(REQUEST['url'], REQUEST)

if __name__ == "__main__":

		p=RSSParser()
		p.parse_url("http://xmlhack.heddley.com/rss.php")

